
open Ast

let constructInitialPredicates predFile =
  let readAndAddPredicates filename =
    let doParse inchan =
      let lexbuf = Lexing.from_channel inchan in
      Inputparse.main Inputflex.token lexbuf 
    in
    ignore (Message.msg_string Message.Normal "Reading in seed predicates...");
    try
      let inchan = open_in filename
      in
      let a = doParse inchan
      in
	ignore (Message.msg_string Message.Normal "Seed predicates read.\n") ;	
	List.iter (fun a -> Message.msg_string Message.Normal (Predicate.toString a)) a ;
	Message.msg_string Message.Normal ("Read "^(string_of_int (List.length a))^" predicates");
	a
    with
      Sys_error _ -> (Message.msg_string Message.Error ("Cannot find predicate information in "^filename^".\n"); [])
    | e -> (Message.msg_string Message.Error (Printexc.to_string e); [])
  in
  if (predFile = "") then
    (* Nothing to do *)
    []
  else
    readAndAddPredicates predFile

